; ---USAGE---

; `python3 ok -q QUESTION`

; e.g. `python3 ok -q shapeshift`


;;; Discussion 13 - Macros ;;;


(define x '(+ 1 1))
(define y '(+ 2 3))

; Q5 - shapeshift
;;; Tests
; (eval '(begin (+ 1 1) (+ 2 3)))
; expect 5
; `(begin ,x ,y)
; expect (begin (+ 1 1) (+ 2 3))
; (list 'begin x y)
; expect (begin (+ 1 1) (+ 2 3))
; (cons 'begin (cons x (cons y nil)))
; expect (begin (+ 1 1) (+ 2 3))


; Q6 - max
;;; Tests
; (max 5 10)
; expect 10
; (max 12 12)
; expect 12
; (max 100 99)
; expect 100

(define-macro (max expr1 expr2)
  `(if (>= ,expr1 ,expr2) ,expr1 ,expr2)
)

(define-macro (max expr1 expr2)
  (list 'if (list '>= expr1 expr2) expr1 expr2)
)

(define-macro (max expr1 expr2)
  (cons 'if
    (cons
      (cons '>= (cons expr1 (cons expr2 nil)))
      (cons expr1 (cons expr2 nil))
    )
  )
)


; Q7 - when
;;; Tests
; (when (= 1 0) ((/ 1 0) 'error))
; expect okay
; (when (= 1 1) ((print 6) (print 1) 'a))
; expect 6
; expect 1
; expect a

(define-macro (when condition exprs)
  `(if ,condition ,(cons 'begin exprs) 'okay)
)
